{{#if memo}}
import { memo } from 'react';
{{/if}}

{{#if wantActionsAndReducer}}

import { compose } from 'redux'
import { connect } from 'react-redux'
import { createStructuredSelector } from 'reselect'

import {
    {{ camelCase name }}Fetch,
    {{ camelCase name }}Save,
    {{ camelCase name }}Merge
} from './actions'

import {
  makeSelect{{properCase name}}
} from './selectors';

const mapStateToProps = createStructuredSelector({
  {{ camelCase name }}: makeSelect{{properCase name}}(),
});

const mapDispatchToProps = {
  on{{properCase name}}Merge: {{ camelCase name }}Merge,

{{#if wantSaga}}
  on{{properCase name}}Fetch: {{ camelCase name }}Fetch,
  on{{properCase name}}Save: {{ camelCase name }}Save,
{{/if}}
}

const withConnect = connect(
  mapStateToProps,
  mapDispatchToProps,
)

{{/if}}
export default compose(
{{#if wantActionsAndReducer}}
  withConnect,
{{/if}}
{{#if memo}}
  memo,
{{/if}}
)